#pragma once
#include <iostream>
#include <fstream>
#include <chrono>
#include <string>
#include <vector>
#include <stack>
#include <queue>
#include <unordered_map>
#include <map>

template <typename Output>
struct SDay {
	std::string name;
	std::ifstream input;

	//Constructor and Destructor
	SDay(std::string name);
	~SDay();

	virtual Output part1() const = 0;
	virtual Output part2() const = 0;
};

template <typename Output>
SDay<Output>::SDay(std::string name) {
	this->name = name;
	input.open("input/" + name, std::ios::in);
}

template <typename Output>
SDay<Output>::~SDay() {
	input.close();
}

