#include "days/days.h"

template <typename Output>
void runSolutions() {
	//Heap allocate all solutions
	std::vector<SDay<Output>*> solutions = {
		new SDay01<Output>("day01"),
		new SDay02<Output>("day02"),
		new SDay03<Output>("day03"),
		new SDay04<Output>("day04"),
		new SDay05<Output>("day05"),
		new SDay06<Output>("day06"),
		new SDay07<Output>("day07"),
		new SDay08<Output>("day08"),
		new SDay09<Output>("day09"),
		new SDay11<Output>("day11"),
		new SDay12<Output>("day12"),
		new SDay13<Output>("day13"),
		new SDay14<Output>("day14"),
		new SDay15<Output>("day15"),
		new SDay16<Output>("day16"),
		new SDay17<Output>("day17"),
		new SDay18<Output>("day18"),
		new SDay19<Output>("day19"),
		new SDay20<Output>("day20"),
		new SDay21<Output>("day21"),
		new SDay22<Output>("day22"),
		new SDay23<Output>("day23"),
		new SDay24<Output>("day24"),
		new SDay25<Output>("day25"),
	};

	for (auto& solution : solutions)
	{//Run each day in turn, recording execution times for each part
		std::cout << "          Name         Part 1           Part 2        Elapsed\n";
		std::cout << "=================================================================\n";
		std::cout << "         " << solution->name;

		//Run solutions and keep timer on each
		std::ofstream output("output/" + solution->name);

		auto start = std::chrono::steady_clock::now();
		output << solution->part1() << std::endl;
		std::chrono::duration<double> part1Time = std::chrono::steady_clock::now() - start;
		output << solution->part2();
		std::chrono::duration<double> part2Time = std::chrono::steady_clock::now() - start - part1Time;
		std::chrono::duration<double> elapsedTime = std::chrono::steady_clock::now() - start;

		std::cout << "         " << 1e3 * part1Time.count() << "ms       " << 1e3 * part2Time.count() << "ms        " << 1e3 * elapsedTime.count() << "ms\n" << std::endl;

		//Free memory for heap allocated solution
		delete solution;

	}
}

int main() {
	runSolutions<int>();
}
